%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Finding Cuboids in RGBD images
%    
%   Boston College     
%   Hao Jiang
%
% ----------------------------------------
%   For details see our CVPR 13 paper.
% ----------------------------------------
%    
%   Dependency: 
%     Install GLPK and change
%     the directory in showresult_proj(...)
% ----------------------------------------
%
%   The code was tested in Linux (64bit) 
%   and Intel-Mac (64bit). 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

nnn = 800;
cmd = sprintf('load rgbd%d.mat', nnn);
eval(cmd);
z = -z;
save rgbd.mat x y z r g b mask;
cmd = sprintf('cp color%d.ppm color.ppm', nnn);
system(cmd);

fillhole2;
normal2;
n_cluster_new;
pairdist2;
localcost_new2;
box_num = topbox_new;
pairwisecost2(box_num);
pairwiseoverlap2(box_num);
showresult_proj(box_num);


