function localcost_new()
load rgbd.mat;
seg = load('seg.txt');
xx = x(1:10:480, 1:10:640); xx = xx(:);
yy = y(1:10:480, 1:10:640); yy = yy(:);
zz = z(1:10:480, 1:10:640); zz = zz(:);

minx = min(xx); maxx = max(xx);
miny = min(yy); maxy = max(yy);
minz = min(zz); maxz = 0;

N = 100;
M = floor((maxy-miny) / (maxx - minx) * N);
K = floor((maxz-minz) / (maxx - minx) * N);

empty_vol = zeros(N,M,K); 
solid_vol = zeros(N,M,K);
for n = 1 : length(xx)
    u = floor((xx(n)-minx)/(maxx-minx) * (N-1)) + 1;
    v = floor((yy(n)-miny)/(maxy-miny) * (M-1)) + 1;
    w = floor((zz(n)-minz)/(maxz-minz) * (K-1)) + 1;
    empty_vol(u,v,w:end) = 1;
    solid_vol(u,v,1:w-1) = 1;
end

[n,m,k] = ind2sub(size(empty_vol),find(empty_vol == 1)); 
ue = (n-1) / (N-1) * (maxx-minx) + minx;
ve = (m-1) / (M-1) * (maxy-miny) + miny;
we = (k-1) / (K-1) * (maxz-minz) + minz;
 
[n,m,k] = ind2sub(size(solid_vol),find(solid_vol == 1));
us = (n-1) / (N-1) * (maxx-minx) + minx;
vs = (m-1) / (M-1) * (maxy-miny) + miny;
ws = (k-1) / (K-1) * (maxz-minz) + minz;

[n,m,k] = ind2sub(size(solid_vol),find(solid_vol == 0));
uo = (n-1) / (N-1) * (maxx-minx) + minx;
vo = (m-1) / (M-1) * (maxy-miny) + miny;
wo = (k-1) / (K-1) * (maxz-minz) + minz;

pairs = load('list.txt');
pairs = floor(pairs);
textprogressbar('localcost: ');
len = size(pairs, 1);
for n = 1 : len
   textprogressbar(n/len*100);
   [minx1, miny1, minz1, maxx1, maxy1, maxz1, TF1, TR1, x11, y11, z11, x21, y21, z21, plane1, plane2, rr1, rr2] = get_box3(x, y, z, seg, pairs(n,1), pairs(n,2), mask);
   %figure(1);
   %plot_pointx(x11, y11, z11, x21, y21, z21);
   %hold on;
   %plot_box(minx1, miny1, minz1, maxx1, maxy1, maxz1, TR1);
   %hold on;
   %axis equal;
   
   %figure(2);
   %plot_normalized_box(minx1, miny1, minz1, maxx1, maxy1, maxz1);
   %hold on;
   %plot_normalized_pointx(x12, y12, z12, x22, y22, z22, TF1);
   %hold on;
   %plot_box(minx2, miny2, minz2, maxx2, maxy2, maxz2, TF1*TR2);
   %hold on;

   %myvol(vol);
   %plot3(x,y,z, '.');
  
   if sum(sum(abs(TF1))) == 0
      cost = 0; costx = 0; costy = 0;
   else 
     P = TF1*[ue ve we ones(length(ue), 1)]';     
     xx = P(1,:); yy = P(2,:); zz = P(3,:);
     e = sum((xx > minx1) & (xx < maxx1) & (yy > miny1) & (yy < maxy1) & (zz > minz1) & (zz < maxz1));

     Q = TF1*[us vs ws ones(length(us), 1)]';
     xx = Q(1,:); yy = Q(2,:); zz = Q(3,:);
     s = sum((xx > minx1) & (xx < maxx1) & (yy > miny1) & (yy < maxy1) & (zz > minz1) & (zz < maxz1));

     Q = TF1*[uo vo wo ones(length(uo), 1)]';
     xx = Q(1,:); yy = Q(2,:); zz = Q(3,:);
     so = sum((xx > minx1) & (xx < maxx1) & (yy > miny1) & (yy < maxy1) & (zz > minz1) & (zz < maxz1));

     cost = s / (s+e+1e-6);
     costx = s / (s+so+1e-6);

     u = (maxx1-minx1)/20;
     v = (maxy1-miny1)/20;
     w = (maxz1-minz1)/20;
     [xx,yy,zz] = meshgrid(minx1:u:maxx1, miny1:v:maxy1, minz1:w:maxz1);
     P = TR1*[xx(:) yy(:) zz(:) ones(length(xx(:)), 1)]';
     u = -(plane1(1)*P(1,:) + plane1(2)*P(2,:) + plane1(4))/plane1(3);
     v = -(plane2(1)*P(1,:) + plane2(2)*P(2,:) + plane2(4))/plane2(3);
     if max(abs(plane1(1:2)))/abs(plane1(3)) > 80
       costy = sum(P(3,:) < v) / 9261;
     elseif max(abs(plane2(1:2)))/abs(plane2(3)) > 80
       costy = sum(P(3,:) < u) / 9261;
     else
       costy = sum(P(3,:) < u & P(3,:) < v) / 9261;
     end

   end

   cmd = sprintf('save boxparam%d.mat minx1 miny1 minz1 maxx1 maxy1 maxz1 TF1 TR1 x11 y11 z11 x21 y21 z21 plane1 plane2 cost costx costy rr1 rr2', n);
   eval(cmd); 
end
textprogressbar('done');

